module Main where

import System.Random
import Graphics.Gloss
import Graphics.Gloss.Data.ViewPort

import Tetromino
import Matriz
import Tabuleiro
import Vetor
import Gerador
import Jogo

g :: [[Maybe Bloco]]
g = [[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ,[Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing]
    ]

p :: Tetromino
p = Tetromino (Matriz layoutZ) (Vetor2D 0 2) OZero

ghost :: Maybe Tetromino
ghost = geraGhost (Matriz g) (Just p) (Vetor2D 0 0)

t :: Tabuleiro
t = Tabuleiro (Matriz g) (Nothing) Nothing

tamX, tamY :: Int
tamX = 1200
tamY = 900

tamTetro :: Float
tamTetro = 40

mostraJogo :: Jogo -> Picture
mostraJogo jogo = do
    let (jogo', pic) = desenhaJogo jogo
    pic

main :: IO ()
main = do
    gen <- getStdGen

    let gerador     = GeradorTetros gen []
    let jogoInicial = inicializaJogo t gerador tamTetro

    let janela = InWindow "Tetris" (tamX, tamY) (50, 50)
    
    play
        janela
        black
        60
        jogoInicial
        mostraJogo
        eventHandler
        proxEstado
        